{
  inputs = {
    nixpkgs.url = "github:nixos/nixpkgs/23.11";
    haskell-flake.url = "github:srid/haskell-flake";
    parts.url = "github:hercules-ci/flake-parts";
  };
  outputs = inputs@{ self, nixpkgs, parts, ... }:
    parts.lib.mkFlake { inherit inputs; } {
      systems = nixpkgs.lib.systems.flakeExposed;
      imports = [ inputs.haskell-flake.flakeModule ];

      perSystem = { self', pkgs, ... }: {
        haskellProjects.default = {
          basePackages = pkgs.haskellPackages;
          packages = {
            http2.source = "3.0.3";
          };
          devShell = {
           enable = true;
           tools = hp: { fourmolu = hp.fourmolu; };
           hlsCheck.enable = true;
          };
        };

        packages.default = self'.packages.sampu;
      };
    };
}
