module Core.HTTP where

import qualified Core.Handlers  as Handle

import Network.Wai.Middleware.RequestLogger (logStdoutDev)
import Network.Wai.Handler.Warp (Port, run)
import Web.Twain

main :: IO ()
main = do
  run appPort $
    foldr ($) (notFound Handle.missing) app

-- Combine our Preprocessor Middlewares and Routes to create an App
app :: [Middleware]
app = preProcessors ++ routes

-- These Middleware are always executed before any routes are reached
preProcessors :: [Middleware]
preProcessors = [logStdoutDev]

-- The application's core routes expressed as a list of WAI middlewares
routes :: [Middleware]
routes =
  [ get "/" Handle.index
  , get "/echo/:testParam" Handle.testRoute
  ]

-- This will be replaced with getEnv located in Configuration
appPort :: Port
appPort = 3000
